/*
 * RC.c
 *
 * Created: 19/02/2016 15:07:16
 * Author : cechjir
 */ 

#define F_CPU 8000000 //CPU clock frequency
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#define PERIOD_RC 13.8888 //half period of the 36kHz carrier
#define RC5_ADDRESS 26 //RC 5 address

signed char i; //iterator

void pulse(){
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
	
	PORTD|=0b01000000;
	_delay_us(PERIOD_RC);
	PORTD&=0b10111111;
	_delay_us(PERIOD_RC);
}

void wait(){
	_delay_us(889);
}

void tx(unsigned char state){
	switch(state){
		case 0:
		wait();
		pulse();
		break;

		case 1:
		pulse();
		wait();
		break;

	}

}

//Send command via IR RC5
void RC5_write(unsigned char command){
	tx(1); //Start bit #1
	tx(1); //Start bit #2
	tx(0); //Toggle bit
	
	for(i=4; i!=-1; i--){ //Address
		tx((RC5_ADDRESS>>i)&0b00000001);
	}
	
	for(i=5; i!=-1; i--){ //Command
		tx((command>>i)&0b00000001);
	}
	
}


//Interrupt service routines which carries pin change interrupt request:
ISR(PCINT0_vect){
	switch(PINB){
		case 0b11111110:
		RC5_write(6); //MENU
		break;
		
		case 0b11111101:
		RC5_write(0); //RED
		break;
		
		case 0b11111011:
		RC5_write(7); //EFFECT
		break;
		
		case 0b11110111:
		RC5_write(1); //GREEN
		break;
		
		case 0b11101111:
		RC5_write(3); //LEVEL
		break;
		
		case 0b11011111:
		RC5_write(2); //BLUE
		break;
		
		case 0b10111111:
		RC5_write(11); //LOCK
		break;
		
		case 0b01111111:
		RC5_write(8); //OK
		break;
	}
		while(PINB!=0xFF){}
		_delay_ms(10);
}

ISR(PCINT2_vect){
	switch(PIND|0b11000011){
		case 0b11111011:
		RC5_write(10); //-
		break;
		
		case 0b11110111:
		RC5_write(9); //+
		break;
		
		case 0b11101111:
		RC5_write(5); //BLACK
		break;
		
		case 0b11011111:
		RC5_write(4); //WHITE
		break;
	}
		while((PIND|0b11000011)!=0xFF){}
		_delay_ms(10);
}

void sleep(){
	MCUCR|=0b00100000; //Enable sleep instr. execution
	asm("sleep");
}

int main(void)
{
	MCUCR=0b01010000; //PowerDown enabled
	PCMSK0=0b11111111; //Pin change interrupt on PCINT[0..7]
	PCMSK2=0b00111100; //Pin change interrupt on PCINT[13..16]
	GIMSK=0b00110000; //PCINT0, PCINT2:EN 
	DDRD=0b01000000;  //SET pin D6 as an output
	PORTB=0b11111111; //Enable pull-up resistors
	PORTD=0b00111100; //Enable corresponding pull-up resistors	+ IR
	
	asm("sei"); //Global enable interrupts
    /* Replace with your application code */
    while (1) 
    {
		sleep();
    }
}

